/*
 * Unique Schlüssel für JPA Entität
 */
package de.ivu.elect.business.veranstaltung.entity;
import java.util.function.Function;
import java.util.ArrayList;
import java.util.stream.Collectors;

@javax.enterprise.inject.Vetoed
public class VeranstaltungUK
implements de.ivu.elect.jee.entity.tk.EntityUK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

    protected final java.lang.String externeId;

    public java.lang.String getExterneId(){
      return externeId;
    }

  protected final de.ivu.elect.business.gebietsbaum.entity.GebietUK gebietUK;

    public de.ivu.elect.business.gebietsbaum.entity.GebietUK getGebietUK(){
      return gebietUK;
    }
  protected final de.ivu.elect.business.wahl.entity.WahlUK wahlUK;

    public de.ivu.elect.business.wahl.entity.WahlUK getWahlUK(){
      return wahlUK;
    }
  protected final de.ivu.elect.business.wahl.entity.WahlterminUK wahlterminUK;

    public de.ivu.elect.business.wahl.entity.WahlterminUK getWahlterminUK(){
      return wahlterminUK;
    }

  public VeranstaltungUK(
java.lang.String externeId
,   de.ivu.elect.business.gebietsbaum.entity.GebietUK gebietUK
,   de.ivu.elect.business.wahl.entity.WahlUK wahlUK
,   de.ivu.elect.business.wahl.entity.WahlterminUK wahlterminUK
  ) {
    super();


      this.externeId = externeId;
        this.gebietUK = gebietUK;
      this.wahlUK = wahlUK;
      this.wahlterminUK = wahlterminUK;
    }

  @Override
  public int hashCode() {
        int result = 1;
    
    
                    result = result + ((externeId == null) ? 0 : externeId.hashCode());
        
                    result = result + ((gebietUK == null) ? 0 : gebietUK.hashCode());
                    result = result + ((wahlUK == null) ? 0 : wahlUK.hashCode());
                    result = result + ((wahlterminUK == null) ? 0 : wahlterminUK.hashCode());
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    
    if (getClass() != obj.getClass()) {
      return false;
    }

            VeranstaltungUK other = (VeranstaltungUK) obj;

                if (externeId == null) {
          if (other.externeId != null) {
            return false;
          }
        } else if (!externeId.equals(other.externeId)) {
          return false;
        }
        
                if (gebietUK == null) {
          if (other.gebietUK != null) {
            return false;
          }
        } else if (!gebietUK.equals(other.gebietUK)) {
          return false;
        }
                if (wahlUK == null) {
          if (other.wahlUK != null) {
            return false;
          }
        } else if (!wahlUK.equals(other.wahlUK)) {
          return false;
        }
                if (wahlterminUK == null) {
          if (other.wahlterminUK != null) {
            return false;
          }
        } else if (!wahlterminUK.equals(other.wahlterminUK)) {
          return false;
        }
            
    return true;
  }

  @Override
  public String getEntityMessageKey() {
    return VeranstaltungConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    result.addAll(gebietUK.getAllEntityFieldValues());
    result.addAll(wahlUK.getAllEntityFieldValues());
    result.addAll(wahlterminUK.getAllEntityFieldValues());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(VeranstaltungConstants.MESSAGE_KEY_ENTITY_EINZAHL, VeranstaltungConstants.MESSAGE_KEY_EXTERNE_ID_EINZAHL, externeId));
        
        return result;
      }
  
    @Override
  public String toString() {
    return "VeranstaltungUK[" + toStringParameter() + "]";
  }

            protected String toStringParameter() {
              String result = ""

                                                        +"externeId="+externeId
                                        +", "                +"gebietUK="+gebietUK
                            +", "                +"wahlUK="+wahlUK
                            +", "                +"wahlterminUK="+wahlterminUK
                        ;
                          return result;
            
            }




          public String allUKFields() {
    return String.join(", ", getAllUKFieldValues().stream()
         .map(object -> (object != null ? object.toString() : null))
         .collect(Collectors.toList()));
    }

   protected ArrayList<Object> getAllUKFieldValues() {
              ArrayList<Object> list = new ArrayList<>();
              list.add(externeId);
     return list;
   }

            public static <E extends Veranstaltung> java.util.Map<VeranstaltungUK, E> mappeVeranstaltungNachUK(java.util.Collection<E> entities) {

                return entities.stream().collect(java.util.stream.Collectors.toMap(Veranstaltung::getVeranstaltungUK, Function.<E>identity(), (u,v)->v));
             }


                public static Function<Veranstaltung, VeranstaltungUK> getVeranstaltungToUKFunction() {
                return Veranstaltung::getVeranstaltungUK;
                }

}
